You are not logged in.

#1 2022-11-05 01:27:08

Terrior
Member
Registered: 2022-08-10
Posts: 10

OpenSSL update broken Cargo (Rust)

It seems like there's recently been posts about the new openssl change. I've ran into a major issue with this, I program in Rust on the daily and every time I try to use cargo I get this error:

cargo: error while loading shared libraries: libssl.so.3: cannot open shared object file: No such file or directory

Suggestions on how to fix this?

Last edited by Terrior (2022-11-05 01:29:46)

Offline

#2 2022-11-05 01:28:05

Scimmia
Fellow
Registered: 2012-09-01
Posts: 9,799

Re: OpenSSL update broken Cargo (Rust)

libssl.so.3 is the current version. Update your *entire* system.

Partial updates are not supported.

Last edited by Scimmia (2022-11-05 01:28:20)

Offline

#3 2022-11-05 01:30:24

Terrior
Member
Registered: 2022-08-10
Posts: 10

Re: OpenSSL update broken Cargo (Rust)

:: Starting full system upgrade...
 there is nothing to do

Offline

#4 2022-11-05 01:32:23

Scimmia
Fellow
Registered: 2012-09-01
Posts: 9,799

Re: OpenSSL update broken Cargo (Rust)

what does pacman -Q openssl show?

Offline

#5 2022-11-05 01:33:01

loqs
Member
Registered: 2014-03-06
Posts: 15,477

Re: OpenSSL update broken Cargo (Rust)

What is the output of

pacman -Q openssl
which rust
lddtree $(which rust)

Offline

#6 2022-11-05 01:33:01

Terrior
Member
Registered: 2022-08-10
Posts: 10

Re: OpenSSL update broken Cargo (Rust)

[terrior@MonoWolfPC ~]$ pacman -Q openssl
openssl 1.1.1.q-1

Offline

#7 2022-11-05 01:33:40

loqs
Member
Registered: 2014-03-06
Posts: 15,477

Re: OpenSSL update broken Cargo (Rust)

Change your system's primary mirror.
Edit:
Your current mirror has not updated core but is has updated extra,  hence the breakage.

Last edited by loqs (2022-11-05 01:34:33)

Offline

#8 2022-11-05 01:34:49

Terrior
Member
Registered: 2022-08-10
Posts: 10

Re: OpenSSL update broken Cargo (Rust)

Oh sorry, here's the full thing

[terrior@MonoWolfPC ~]$ pacman -Q openssl
openssl 1.1.1.q-1
[terrior@MonoWolfPC ~]$ which rust
which: no rust in (/home/terrior/.local/bin:/usr/local/bin:/usr/bin:/bin:/usr/local/sbin:/home/terrior/.dotnet/tools:/usr/lib/jvm/default/bin:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl)
[terrior@MonoWolfPC ~]$ lddtree $(which rust)
which: no rust in (/home/terrior/.local/bin:/usr/local/bin:/usr/bin:/bin:/usr/local/sbin:/home/terrior/.dotnet/tools:/usr/lib/jvm/default/bin:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl)
bash: lddtree: command not found
[terrior@MonoWolfPC ~]$ sudo pacman -S lddtree
error: target not found: lddtree

rust is not a command, you usually use either rustc or cargo, if that's what you meant

[terrior@MonoWolfPC ~]$ which cargo
/usr/bin/cargo
[terrior@MonoWolfPC ~]$ which rustc
/usr/bin/rustc

Offline

#9 2022-11-05 01:53:47

tejohnso
Member
Registered: 2014-01-23
Posts: 7

Re: OpenSSL update broken Cargo (Rust)

This is happening to me as well but for rtorrent. Apparently libtorrent was upgraded to expect openssl3 but my system is on openssl 1.1.1.q-1.

My mirror is apparently sync'd up according to pacman -Syu --debug and https://archlinux.org/mirrors/status/

Offline

#10 2022-11-05 01:54:40

Terrior
Member
Registered: 2022-08-10
Posts: 10

Re: OpenSSL update broken Cargo (Rust)

Currently running rankmirrors on my system, I expected an rtfm so I'm gonna try various things.

Offline

#11 2022-11-05 01:54:43

Scimmia
Fellow
Registered: 2012-09-01
Posts: 9,799

Re: OpenSSL update broken Cargo (Rust)

What mirror would that be?

Offline

#12 2022-11-05 01:57:12

tejohnso
Member
Registered: 2014-01-23
Posts: 7

Re: OpenSSL update broken Cargo (Rust)

Offline

#13 2022-11-05 02:00:07

Scimmia
Fellow
Registered: 2012-09-01
Posts: 9,799

Re: OpenSSL update broken Cargo (Rust)

That mirror has the correct version of openssl. You've got something else going on.

Offline

#14 2022-11-05 02:06:17

Terrior
Member
Registered: 2022-08-10
Posts: 10

Re: OpenSSL update broken Cargo (Rust)

I must say, thank you a lot, I noticed a ton of other stuff on my system was also broken to the new ssl update, but after updating my mirrors everything's fixed.

Offline

#15 2022-11-05 02:08:05

tejohnso
Member
Registered: 2014-01-23
Posts: 7

Re: OpenSSL update broken Cargo (Rust)

I noticed some 404s in the .sig files in pacman -Syu --debug output so I blocked out that mirror and reran pacman -Syu --debug. No 404s and a whole bunch of upgrades, including openssl. Problem solved.

Offline

#16 2022-11-05 02:19:34

cbc02009
Member
Registered: 2021-06-06
Posts: 7

Re: OpenSSL update broken Cargo (Rust)

I am having the same issue, although I'm on the correct version of openssl. It's broken ZFS, which is a bit of a problem...

❯ _ pacman -Q openssl
openssl 3.0.7-2
❯ zfs list
zfs: error while loading shared libraries: libcrypto.so.1.1: cannot open shared object file: No such file or directory
❯ paru
paru: error while loading shared libraries: libssl.so.1.1: cannot open shared object file: No such file or directory

Last edited by cbc02009 (2022-11-05 02:20:20)

Offline

#17 2022-11-05 02:22:08

Scimmia
Fellow
Registered: 2012-09-01
Posts: 9,799

Re: OpenSSL update broken Cargo (Rust)

Packages from outside the repos are your responsibility to rebuild when necessary.

Offline

#18 2022-11-05 02:33:07

Toolybird
Member
Registered: 2017-09-30
Posts: 53

Re: OpenSSL update broken Cargo (Rust)

> It's broken ZFS

As a workaround you could try to install the "openssl-1.1" package. It worked for me on my sole ZFS system. Tip from [1].

[1] https://github.com/archzfs/archzfs/issues/464

Offline

#19 2022-11-05 02:35:37

cbc02009
Member
Registered: 2021-06-06
Posts: 7

Re: OpenSSL update broken Cargo (Rust)

Toolybird wrote:

> It's broken ZFS

As a workaround you could try to install the "openssl-1.1" package. It worked for me on my sole ZFS system. Tip from [1].

[1] https://github.com/archzfs/archzfs/issues/464

Thanks, just saw that. I'm gonna have to install a video card and chroot into the machine to fix it, but at least it should work.

Offline

#20 2022-11-05 02:36:35

Scimmia
Fellow
Registered: 2012-09-01
Posts: 9,799

Re: OpenSSL update broken Cargo (Rust)

Don't use a crappy workaround. Fix it by rebuilding your out-of-repo packages.

Offline

#21 2022-11-05 11:39:40

njkevlani
Member
From: India
Registered: 2017-12-29
Posts: 5
Website

Re: OpenSSL update broken Cargo (Rust)

I was having the same issue with paru-bin. Reinstalling did not help.

What worked for me was: installing paru (non-bin version).

Offline

#22 2022-11-06 06:19:54

dainbrump
Member
From: VA, United States
Registered: 2022-11-06
Posts: 1

Re: OpenSSL update broken Cargo (Rust)

I ran into the same error while updating cargo. I verified that I was running the latest version of openssl with:

pacman -Q openssl

You should see openssl 3.0.7-2 or newer if you're in the future.

Then I went to make sure cargo-update itself was up to date. My first run of cargo install cargo-update yielded an "all's well" message. I promptly called my machine a liar aloud and proceeded with cargo install cargo-update --force. Cargo did some things, specifically re-installing the cargo-install-update and cargo-install-update-config. I stopped getting that error message. YMMV.

Offline

#23 2022-11-06 14:16:52

ectospasm
Member
Registered: 2015-08-28
Posts: 136

Re: OpenSSL update broken Cargo (Rust)

Note that some software cannot be easily built against OpenSSL 3.  I have Ubiquiti UniFi hardware on my network, so I depend on the unifi package.  This package depends on an old version of MongoDB (v4.0), which only exists in the AUR as a binary package (mongodb40-bin).  Building mongodb v4.0 requires Python 2.7, which is no longer provided by Arch. 

Installing openssl-1.1 is an acceptable workaround in this case, without resorting to installing more end of life software on my system.

Offline

#24 2022-11-06 14:19:22

Scimmia
Fellow
Registered: 2012-09-01
Posts: 9,799

Re: OpenSSL update broken Cargo (Rust)

Sure

Note that unifi works fine with newer versions of mongodb, though, up to and including 5.0. All of the pre-built binaries do require the old openssl, though.

Offline

#25 2022-11-06 21:51:29

mostlyharmless
Member
Registered: 2014-01-16
Posts: 72

Re: OpenSSL update broken Cargo (Rust)

cmake (3.24.3-1) is also broken by this openssl 1.1->3.0.7-2 update,  installing the openssl-1.1 package fixes it. Pity this wasn't coordinated better.

Last edited by mostlyharmless (2022-11-06 21:52:45)

Offline

Board footer

Powered by FluxBB